"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importDefault(require("react"));
const react_native_1 = require("react-native");
const theme_1 = require("../Styles/theme");
const ActionSheet = props => {
    const { visible, cancelText = '取消', actions, onClose, onClickItem } = props;
    return (react_1.default.createElement(react_native_1.Modal, { visible: visible, transparent: true, animationType: "slide", statusBarTranslucent: true, onRequestClose: onClose },
        react_1.default.createElement(react_native_1.View, { style: styles.container },
            react_1.default.createElement(react_native_1.View, { style: styles.top }),
            react_1.default.createElement(react_native_1.View, { style: styles.sheet },
                actions.map((item, index) => {
                    const { name, subName, color, fontSize, disabled } = item;
                    const style = {};
                    color && (style.color = color);
                    fontSize && (style.fontSize = fontSize);
                    return (react_1.default.createElement(react_native_1.TouchableHighlight, { key: index, activeOpacity: 0.6, underlayColor: theme_1.Theme.fillBody, onPress: () => onClickItem(index), disabled: disabled, style: [styles.sheetItem, index === 0 && styles.noBorder] },
                        react_1.default.createElement(react_1.default.Fragment, null,
                            react_1.default.createElement(react_native_1.View, null,
                                react_1.default.createElement(react_native_1.Text, { style: [styles.sheetText, style, disabled && styles.disabledText] }, name)),
                            !!subName && (react_1.default.createElement(react_native_1.View, { style: styles.sub },
                                react_1.default.createElement(react_native_1.Text, { style: styles.subText }, subName))))));
                }),
                react_1.default.createElement(react_native_1.TouchableHighlight, { activeOpacity: 0.6, underlayColor: theme_1.Theme.fillBody, onPress: onClose, style: [styles.sheetItem, styles.noBorder, styles.cancel] },
                    react_1.default.createElement(react_native_1.Text, { style: styles.sheetText }, cancelText))))));
};
const styles = react_native_1.StyleSheet.create({
    container: {
        flex: 1,
        backgroundColor: theme_1.Theme.fillMask,
    },
    top: {
        flex: 1,
    },
    sheet: {
        backgroundColor: theme_1.Theme.fillBody,
        borderTopLeftRadius: 10,
        borderTopRightRadius: 10,
        overflow: 'hidden',
    },
    sheetItem: {
        backgroundColor: theme_1.Theme.fillBase,
        paddingVertical: 15,
        justifyContent: 'center',
        alignItems: 'center',
        borderTopColor: theme_1.Theme.borderColor,
        borderTopWidth: 0.5,
    },
    noBorder: {
        borderTopWidth: 0,
    },
    sheetText: {
        fontSize: 15,
        color: theme_1.Theme.colorTextBase,
    },
    disabledText: {
        color: theme_1.Theme.colorTextDisabled,
    },
    sub: {
        marginTop: 4,
    },
    subText: {
        fontSize: 12,
        color: theme_1.Theme.colorTextSecondary,
    },
    cancel: {
        marginTop: 8,
    },
});
exports.default = ActionSheet;
