"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importDefault(require("react"));
const react_native_1 = require("react-native");
const theme_1 = require("../../components/Styles/theme");
const Icon_1 = __importDefault(require("../Icon"));
const WithWrap = props => {
    const { children, clickable, style, onPress } = props;
    if (clickable) {
        return (react_1.default.createElement(react_native_1.TouchableHighlight, { style: style, activeOpacity: 0.6, underlayColor: theme_1.Theme.fillBody, onPress: onPress },
            react_1.default.createElement(react_1.default.Fragment, null, children)));
    }
    return react_1.default.createElement(react_native_1.View, { style: style }, children);
};
const Cell = props => {
    const { title, label, value, border = true, isLink, centerRightText = true, rightIconName = 'right', rightIconSize = 24, rightIconColor = theme_1.Theme.colorTextSecondary, clickable, style, onPress, renderLeftIcon, } = props;
    return (react_1.default.createElement(WithWrap, { style: [styles.container, border && styles.border, style], clickable: clickable, onPress: onPress },
        react_1.default.createElement(react_native_1.View, { style: styles.left },
            react_1.default.createElement(react_native_1.View, { style: styles.titleWrap },
                renderLeftIcon ? react_1.default.createElement(react_native_1.View, { style: styles.iconWrap }, renderLeftIcon()) : null,
                react_1.default.createElement(react_native_1.Text, { style: styles.titleText }, title)),
            !!label && (react_1.default.createElement(react_native_1.View, { style: styles.titleLabelWrap },
                react_1.default.createElement(react_native_1.Text, { numberOfLines: 1, style: styles.titleLabel }, label)))),
        react_1.default.createElement(react_native_1.View, { style: { alignSelf: centerRightText ? 'center' : 'flex-start' } },
            value && react_1.default.createElement(react_native_1.Text, null, title),
            isLink && react_1.default.createElement(Icon_1.default, { name: rightIconName, size: rightIconSize, color: rightIconColor }))));
};
const styles = react_native_1.StyleSheet.create({
    container: {
        flexDirection: 'row',
        alignItems: 'center',
        paddingVertical: 12,
        paddingHorizontal: 10,
    },
    border: {
        borderBottomColor: theme_1.Theme.borderLightColor,
        borderBottomWidth: 0.5,
    },
    left: {
        flex: 1,
    },
    titleWrap: {
        flexDirection: 'row',
        alignItems: 'center',
    },
    iconWrap: {
        marginRight: 6,
    },
    titleText: {
        fontSize: 16,
        color: theme_1.Theme.colorTextParagraph,
    },
    titleLabelWrap: {
        marginTop: 4,
    },
    titleLabel: {
        fontSize: 12,
        color: theme_1.Theme.colorTextCaption,
    },
});
exports.default = Cell;
