"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importStar(require("react"));
const react_native_1 = require("react-native");
const theme_1 = require("../../components/Styles/theme");
let timer = null;
let autoplayTimer = null;
const Swiper = props => {
    const { children, width, current = 0, indicatorMode = 'round', indicatorPosition = 'bottomCenter', autoplay = false, interval = 2500, 
    // duration = 500,
    // circular = true,
    borderRadius = 8, backgroundColor, onChange, } = props;
    const swiperItemNumber = [].concat(children).length;
    const $scroll = react_1.useRef(null);
    react_1.useEffect(() => {
        if (!autoplay) {
            autoplayTimer && clearInterval(autoplayTimer);
        }
        else {
            autoplayTimer = setInterval(() => {
                let index = current + 1;
                if (index >= swiperItemNumber) {
                    index = 0;
                }
                $scroll?.current &&
                    $scroll.current.scrollTo({
                        x: index * width,
                        animated: true,
                    });
                onChange && onChange(index);
            }, interval);
        }
        return () => {
            autoplayTimer && clearInterval(autoplayTimer);
        };
    }, [autoplay, interval, current]);
    const getPanes = () => {
        const newChildren = [];
        react_1.Children.map(children, (child, idx) => {
            newChildren.push(react_1.cloneElement(child, {
                key: idx,
                width,
                borderRadius,
            }));
        });
        return newChildren;
    };
    const renderIndicator = () => {
        const top = ['topLeft', 'topCenter', 'topRight'].includes(indicatorPosition);
        const left = ['topLeft', 'bottomLeft'].includes(indicatorPosition);
        const center = ['topCenter', 'bottomCenter'].includes(indicatorPosition);
        const right = ['topRight', 'bottomRight'].includes(indicatorPosition);
        const isNumber = indicatorMode === 'number';
        const isRound = indicatorMode === 'round';
        const isRect = indicatorMode === 'rect';
        const isDot = indicatorMode === 'dot';
        if (indicatorMode === 'none')
            return null;
        return (react_1.default.createElement(react_native_1.View, { style: [
                styles.indicatorWrap,
                top ? styles.wrapTop : styles.wrapBottom,
                left && styles.wrapLeft,
                center && styles.wrapCenter,
                right && styles.wrapRight,
            ] },
            isNumber && (react_1.default.createElement(react_native_1.View, { style: [styles.indicator, styles.indicatorNumber] },
                react_1.default.createElement(react_native_1.Text, { style: styles.indicatorNumberText },
                    current + 1,
                    "/",
                    swiperItemNumber))),
            (isRound || isRect || isDot) && (react_1.default.createElement(react_native_1.View, { style: [styles.indicator] }, new Array(swiperItemNumber).fill(1).map((_, index) => {
                return (react_1.default.createElement(react_native_1.View, { key: index, style: [
                        styles.indicatorItem,
                        index === current && styles.active,
                        isDot && styles.indicatorItemDot,
                        isRect && styles.indicatorItemRect,
                    ] }));
            })))));
    };
    const onScrollEnd = (event) => {
        event.persist();
        if (timer)
            clearTimeout(timer);
        timer = setTimeout(() => {
            const { contentOffset, layoutMeasurement } = event.nativeEvent;
            const { x } = contentOffset;
            const { width } = layoutMeasurement;
            const index = Math.round(x / width);
            onChange && onChange(index);
        }, 20);
    };
    return (react_1.default.createElement(react_native_1.View, { style: { width } },
        react_1.default.createElement(react_native_1.ScrollView, { horizontal: true, pagingEnabled: true, alwaysBounceHorizontal: true, ref: $scroll, showsHorizontalScrollIndicator: false, onMomentumScrollEnd: onScrollEnd, style: {
                width,
                borderRadius,
                backgroundColor,
            } }, getPanes()),
        renderIndicator()));
};
const styles = react_native_1.StyleSheet.create({
    container: {
        overflow: 'hidden',
    },
    indicatorWrap: {
        position: 'absolute',
        left: '10%',
        right: '10%',
        flexDirection: 'row',
        alignItems: 'center',
    },
    wrapTop: {
        top: '10%',
    },
    wrapBottom: {
        bottom: '10%',
    },
    wrapLeft: {
        justifyContent: 'flex-start',
    },
    wrapCenter: {
        justifyContent: 'center',
    },
    wrapRight: {
        justifyContent: 'flex-end',
    },
    indicator: {
        flexDirection: 'row',
        alignItems: 'center',
    },
    indicatorItem: {
        width: 8,
        height: 8,
        borderRadius: 4,
        backgroundColor: theme_1.Theme.fillMask,
        marginLeft: 6,
    },
    active: {
        width: 16,
        backgroundColor: theme_1.Theme.fillBase,
    },
    indicatorNumber: {
        backgroundColor: theme_1.Theme.fillMask,
        paddingHorizontal: 8,
        paddingVertical: 1,
        borderRadius: 10,
    },
    indicatorNumberText: {
        color: theme_1.Theme.colorTextBaseInverse,
        fontSize: 12,
    },
    indicatorItemRect: {
        width: 16,
        height: 4,
        borderRadius: 0,
    },
    indicatorItemDot: {
        width: 8,
    },
});
exports.default = Swiper;
